pipeline {
    agent any

    parameters{

        string(
            name: "vm_username",
            defaultValue: "ubuntu"
        )

        string(
            name: "vm_host",
            defaultValue: "18.221.189.216"
        )

         string(
             name: "vm_path",
             defaultValue: "/home/ubuntu/"
         )
    }

    post {
        always{
            cleanWs()
        }
        failure {
            updateGitlabCommitStatus name: "build", state: "failed"
        }
        success {
            updateGitlabCommitStatus name: "build", state: "success"
        }
    }

    options {
        gitLabConnection("gitlab")
    }

    stages {

        stage("Deploy"){
            when { branch "master"}
            stages{

                stage ("Copy artifact"){
                    steps {
                        script{
                            def targetPath = sh(
                                script: "find target/ -name 'Api-Investimentos-*.jar'",
                                returnStdout: true
                            ).trim()
                        sh "scp -o StrictHostKeyChecking=no ${targetPath} ${params.vm_username}@${params.vm_host}:${params.vm_path}"
                        }
                    }
                }

                stage ("Start service"){
                    steps {
                        sh "ssh -o StrictHostKeyChecking=no -t ${params.vm_username}@${params.vm_host} 'sudo systemctl restart Api-investimentos.service'"
                    }
                }

            }
        }

        stage("Deploy develop") {
            when{not{branch "master"}}

            stages{

                stage("Testes Unitarios"){
                    steps {
                        echo "********iniciar testes unitarios"
                        sh "./mvnw test"
                    }
                }

                stage("Package") {
                    steps {
                        echo "********iniciar build"
                        sh "./mvnw package -DskipTests"
                    }
                }
            }
        }
    }
}
